<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
   
    <title>Real Estate | 24h</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">

    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <script src="https://cdn.datatables.net/buttons/1.5.0/js/dataTables.buttons.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.32/pdfmake.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.32/vfs_fonts.js"></script>
    <script src="https://cdn.datatables.net/buttons/1.5.0/js/buttons.html5.min.js"></script>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>
  </head>

  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        
        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/photo4.jpg"
                class="img-circle elevation-2"
                alt="User Image" 
              />
            </div>
            <div class="info ">
              <a href="#" class="d-block" style="font-size: 25px;">Home 24h</a>
              <a href="#"  style="font-size: 15px; margin: 20px">User:</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu --> <!-- Danh mục quản lý -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Danh mục quản lý
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                <ul class="nav nav-treeview">
                  
                  <li class="nav-item">
                    <a href="Dia chi toa do.html" class="nav-link active">
                      <i class="fa-solid fa-map-location-dot"></i>
                      <p>Địa chỉ tọa độ</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-layer-group"></i>
                      <p>Mặt bằng tầng</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-helmet-safety"></i>
                      <p>Nhà thầu xây dựng</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-compass-drafting"></i>
                      <p>Đơn vị thiết kế</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-user-secret"></i>
                      <p>Nhà đầu tư</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-bezier-curve"></i>
                      <p>Kết nối vùng</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-water-ladder"></i>
                      <p>Tiện ích</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-people-group"></i>
                      <p>Khách hàng</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-user"></i>
                      <p>Người dùng</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-hotel"></i>
                      <p>Dự án xây dựng</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-earth-americas"></i>
                      <p>Địa chính</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-solid fa-building-user"></i>
                      <p>Thông tin BĐS</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="fa-regular fa-thumbs-up"></i>
                      <p>Subscriptions</p>
                    </a>
                  </li>
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content --> 
      <div class="content-wrapper">
        <!-- Content Header (Page header) --> <!-- Login -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <i class="fa-solid fa-house-chimney-window" style="margin: 6px; color: #FF6347;"></i>
                  <li class="breadcrumb-item "><a href="#">Log in</a></li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <!-- List of orders -->
        <div class="contain">
          <h2 class="text-center" style="margin-left: 8px; color: #48D1CC"><font face="calibri"><b>ĐỊA CHỈ TỌA ĐỘ</b></font></h2>
          <div class="jumbotron" style="margin: 10px; padding: 10px;">
            
          <!--  <div class="form-group">
              <button id="insert-new-order1" class="btn btn-primary" style="margin: 10px; border-radius: 10px;" ><i class="fa-solid fa-file-circle-plus"></i> Create</button>
            </div>
          -->  
            <table class="table table-bordered table-striped table-hover" id="order-table">
              <thead>
         
                  <tr>
                    <th> </th>
                    <th>Id</th>
                    <th>Address</th>
                    <th>_Lat</th>
                    <th>_Lng</th>
                  </tr>
         
            </table>
          </div>
        </div>

        <!-- Modal for inserting a new order -->
        <div>
          <div id="insert-order-modal" class="modal fade" tabindex="-1">
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">New address map !!!</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                      <form>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="insert-address">Address <span style="color: red;">(*)</span></label>
                          </div>
                          <div class="col-sm-8">
                            <input type="text" id="insert-address" name="address" class="form-control" placeholder="....">
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="insert-latitude">Latitude (vĩ độ)</span></label>
                          </div>
                          <div class="col-sm-8">
                            <input type="text" id="insert-latitude" name="latitude" class="form-control" placeholder="....">
                          </div>
                        </div>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label for="insert-longitude">Longitude (kinh độ)</label>
                          </div>
                          <div class="col-sm-8">
                            <input type="text" id="insert-longitude" name="longitude" class="form-control" placeholder="....">
                          </div>
                        </div>
                       
                      </form>
                  </div>
                  <div class="modal-footer">
                    <div class="row form-group">
                      <div class="col-sm-6">
                        <button class="col-sm-12 btn btn-primary" id="btn-insert">Insert</button>
                        
                      </div>
                      <div class="col-sm-6">
                        <button class="col-sm-12 btn btn-danger" id="btn-insert-cancel" data-dismiss="modal">Cancel</button>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
          </div>
        </div> 
        
        <!-- Modal for editing-->
        <div>
          <div id="edit-order-modal" class="modal fade " tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Update address map !!!</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="update-address">Address <span style="color: red;">(*)</span></label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" id="update-address" name="address" class="form-control" placeholder="....">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="update-latitude">Latitude (vĩ độ)</span></label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" id="update-latitude" name="latitude" class="form-control" placeholder="....">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="update-longitude">Longitude (kinh độ)</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" id="update-longitude" name="longitude" class="form-control" placeholder="....">
                        </div>
                      </div>
                   
                    <div class="form-group text-right">
                      <div class="col-sm-12">
                        <button class="col-sm-3 btn btn-warning" id="btn-confirm">Edit</button> &nbsp
                        <button class="col-sm-3 btn btn-primary" id="btn-close" data-dismiss="modal">Return</button>
                      </div>
                    </div>
                  </form>
                </div>
              </div>
            </div>
          </div>
        </div>

        <!-- Modal for deleting-->
        <div>
          <div id="delete-order-modal" class="modal fade " tabindex="-1">
            <div class="modal-dialog ">
              <div class="modal-content bg-warning">
                <div class="modal-body">
                  <form>
                    <div class="form-group">
                      <div class="col-sm-12 ">
                        <h3 for="input-order-code">Are you sure to delete this order? </h3>
                      </div>
                    </div>
                    <div class="form-group text-right">
                      <div class="col-sm-12">
                        <button class="col-sm-3 btn btn-success" id="btn-delete">Delete</button> &nbsp
                        <button class="col-sm-3 btn btn-primary" id="btn-close" data-dismiss="modal">Cancel</button>
                      </div>
                    </div>
                  </form>
                </div>
              </div>
            </div>
          </div>
        </div>

    <!-- /.content-wrapper -->
    <footer style="margin-left: 10px;">
      <strong>&copy; 2023 <a href="https://adminlte.io" style="color: #00BFFF;">Home 24h</a>.</strong>
      All rights reserved.
      
    </footer>
</div>
</body>

<script>
"use strict";
$(document).ready(function () {
 
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

  const gBASE_URL = "http://localhost:8080/addressMap";
  var gId = "";


  var gOrdersArr = [];
  const gCOLUMN_ACTION = 0;
  const gCOLUMN_ID = 1;
  const gCOLUMN_ADDRESS = 2;
  const gCOLUMN_LAT = 3;
  const gCOLUMN_LNG = 4;
  
  var gSTT = 0;

  const gUSER_COL = [" ", "id", "address", "latitude", "longitude"]
  
  // set and mapping data table
  var gOrderTable = $("#order-table").DataTable({

    dom: '<"toolbar">',
  
          
    "columns": [
      { "data": gUSER_COL[gCOLUMN_ACTION] },
      { "data": gUSER_COL[gCOLUMN_ID] },
      { "data": gUSER_COL[gCOLUMN_ADDRESS] },
      { "data": gUSER_COL[gCOLUMN_LAT] },
      { "data": gUSER_COL[gCOLUMN_LNG] },
    ],
    
    "columnDefs": [
    
      {
        "targets": gCOLUMN_ACTION,
        "className": "text-center",
        "defaultContent": `
          <i title="Edit" class="fa-solid fa-file-pen edit-order" style="color:orange"></i>
          <i title="Delete" class="fa-regular fa-trash-can delete-order" style="color:red"></i>
          `
      }]
  });

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  
      
  $('.toolbar').html('<button id="insert-new-order" class="btn" style="background-color:#00BFFF; color: white ; margin-left: 8px; border-radius: 10px"><i class="fa-solid fa-file-circle-plus"></i> Create</button>' + " " +
                    '<button id="reload-data" class="btn" style="background-color:#00CED1; color: white ;border-radius: 10px"><i class="fa-solid fa-rotate"></i> Reload</button>');
        
 
  onPageLoading();

  // add event for reloading the table
  $("#reload-data").on('click', function(){
    onPageLoading();
  })


  // add event for opening ADD's modal
  $("#insert-new-order").on('click', function(){
      onOpenAddModalClick(this);
  })

  // add event for the add-confirm button
  $("#btn-insert").on('click', function(){
      onBtnAddConfirmClick(this);
  })

  // add event for opening EDIT's modal
  $("#order-table").on("click", ".edit-order", function () {
      onOpenUpdateModalClick(this); 
  });

  // add event for the edit-confirm button
  $("#btn-confirm").on("click", function () {
      onBtnUpdateConfirmClick(); 
  });

  // add event for the delete modal button
  $("#order-table").on("click", ".delete-order", function () {
      onOpenDeleteModalClick(this); 
  });

  // add event for the delete-confirm button
  $("#btn-delete").on("click", function () {
      onBtnDeleteConfirmClick(); 
  });

  

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  
  // function for loading page
  function onPageLoading() {
        // lấy data từ server
        $.ajax({
          url: gBASE_URL + "/all",
          type: "GET",
          dataType: 'json',
          success: function (responseObject) {
            //debugger;
            console.log(responseObject);
            gOrdersArr = responseObject;
            loadDataToTable(responseObject);
          },
          error: function (error) {
            console.assert(error.responseText);
          }
        });
      }
    
  // ADD BUTTON

      //function for opening Add Modal
      function onOpenAddModalClick(){
        $("#insert-order-modal").modal('show')
      }

      //funtion for Insert Click button
      function onBtnAddConfirmClick(){
        
        //create the new order object
        var vNewObject = {
            address: "",
            latitude: "",
            longitude: "",
        };
        
        //get input data from the modal
        getDataNewAddressModal(vNewObject);
        console.log(vNewObject);
      
        //validate the input data
        var vValidRes = validateDataInsertModal(vNewObject);
        
        if (vValidRes){
          getAjaxAddNewAddress(vNewObject);
        }
      }

  // UPDATE BUTTON

      //function to get data of a row
      function getDataOfARow(paramRow){
        var vRowSelected = $(paramRow).parents('tr');
        var vDatatableRow = gOrderTable.row(vRowSelected);
        var vOrderData = vDatatableRow.data();
        console.log(vOrderData);

        gId = vOrderData.id;

        return vOrderData;
      
      }
          
      //function for Detail Modal
      function onOpenUpdateModalClick(paramDetailButton) {
        
        var vInputData = getDataOfARow(paramDetailButton);
        
        $("#edit-order-modal").modal("show");

        $("#update-address").val(vInputData.address);
        $("#update-latitude").val(vInputData.latitude);
        $("#update-longitude").val(vInputData.longitude);
        
      }

      //function for Update-Confirm Button
      function onBtnUpdateConfirmClick() {
        "use strict";
        console.log("done");
        //create the new order object
        var vNewObject = {
              address: "",
              latitude: "",
              longitude: "" ,
          };

        //get input data from the modal
        getDataUpdateModal(vNewObject);
        console.log(vNewObject);
        console.log(gId);
       
        //validate the input data
        var vValidRes = validateDataInsertModal(vNewObject);

        var vJsonString = JSON.stringify(vNewObject);
        console.log(vJsonString);
                   
        if (vValidRes){
          getAjaxUpdateAddress(gId,vJsonString);
        }
             
      }
      
  // DELETE BUTTON

      //funtion for Delete Modal
      function onOpenDeleteModalClick(paramDeleteButton){
        console.log("delete clicked");
        $("#delete-order-modal").modal("show");

        getDataOfARow(paramDeleteButton);
        console.log(gId)
        
      }

      //funtion for Delete confirmation
      function onBtnDeleteConfirmClick(){
        getAjaxDeleteOrder(gId);
        $("#delete-order-modal").modal("hide");
      }

      
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
  
    // load data to table
    function loadDataToTable(paramResponseObject) {
      //gSTT = 0;
      gOrderTable.clear();
      gOrderTable.rows.add(paramResponseObject);
      gOrderTable.draw();
    }
      
    //function to get input data from the modal
    function getDataUpdateModal(paramOrderObj){

      paramOrderObj.address = $("#update-address").val();
      paramOrderObj.latitude = $("#update-latitude").val();
      paramOrderObj.longitude = $("#update-longitude").val();

    }

    //validate the collected data
    function validateDataInsertModal(paramData){
          
          if (paramData.address === ""){
              alert("Input the ADDRESS please !!!");
              return false;
          }
          if (paramData.latitude === ""){
              alert("Input the LATITUDE please !!!");
              return false;
          }
          if (isNaN(paramData.latitude) === true){
              alert("The LATITUDE must be number !!!");
              return false;
          }
          if (paramData.longitude === ""){
              alert("Input LONGTITUDE please !!!");
              return false;    
          }
          if (isNaN(paramData.longitude) === true){
              alert("The LONGTITUDE must be number !!!");
              return false;
          }
          return true;
      }

    //function for create the new order
    function getDataNewAddressModal(paramOrderObj){

      paramOrderObj.address = $("#insert-address").val();
      paramOrderObj.latitude = $("#insert-latitude").val();
      paramOrderObj.longitude = $("#insert-longitude").val();

    }

    //function to call API for inserting a new order
    function getAjaxAddNewAddress(paramOrder){
          //debugger;
            $.ajax({
            url: gBASE_URL + '/create', 
            type: "POST",
            contentType: "application/json",
            data: JSON.stringify(paramOrder),
            success: function(res){
                console.log(res);
                alert("The address of ID -  " + res.id + "  has been created successfully");
                handleSuccessAjaxCalling();
                $("#insert-order-modal").modal("hide");
            },
            error: function(ajacContext){
                console.log(ajacContext.status);
            }
          })
        };

    //function to call API for updating confirm status
    function getAjaxUpdateAddress(paramOrderId, paramJsonString) {
      $.ajax({
        url: gBASE_URL + '/update' + "/" + paramOrderId,
        data: paramJsonString,
        type: "PUT",
        contentType: "application/json", 
        success: function (res) {
          /*alert("Order Id: " + paramResponse.id + "status is updated succesfully!");
          console.log("%cUPDATED INFORMATION: ", "color:orange");
          console.log(paramResponse);*/
          console.log(res);
          alert("The address of ID -  " + res.id + "  has been updated successfully");
          handleSuccessAjaxCalling()
          $("#edit-order-modal").modal("hide");
        },
        error: function (error) {
          console.log(error.responseText);
        }
      });
    }

    //function to call API for deleting an order
    function getAjaxDeleteOrder(paramOrderId){

      $.ajax({
        url: gBASE_URL + '/delete' + "/" + paramOrderId,
        type: "DELETE",
        success: function(res){
          onPageLoading();
          $("#delete-order-modal").modal("hide");
        },
        error: function(ajaxContext){
          console.log(ajaxContext.status);
        }
      });
    }

    //function for handling the successfull insert
    function handleSuccessAjaxCalling(){
    
      onPageLoading();
      resetDataNewOrderModal();
      
    }

    //function to reset the new order modal
    function resetDataNewOrderModal(){

      $("#insert-address").val("");
      $("#insert-latitude").val("");
      $("#insert-longitude").val("");
    
    }

});

</script>


</html>
